import { ChainId } from "../common";
import { parseUnits } from "@ethersproject/units";
import { BigNumber } from "@ethersproject/bignumber";
export var GasUtils;
(function (GasUtils) {
    const ETH_GAS_PARAMS = {
        maxPriorityFee: parseUnits("1.5", "gwei"),
        bridgeGasLimit: BigNumber.from(100000)
    };
    const BOBA_GAS_PARAMS = {
        gasPrice: parseUnits("10", "gwei"),
        approveGasLimit: BigNumber.from(60000),
    };
    const ARBITRUM_GAS_PARAMS = {
        gasPrice: parseUnits("2.5", "gwei"),
        bridgeGasLimit: BigNumber.from(1500000),
    };
    const AVALANCHE_GAS_PARAMS = {
        gasPrice: parseUnits("150", "gwei"),
        bridgeGasLimit: BigNumber.from(800000),
        approveGasLimit: BigNumber.from(75000),
    };
    const AURORA_GAS_PARAMS = {
        gasPrice: parseUnits('0', 'gwei'),
    };
    function makeGasParams(chainId) {
        switch (chainId) {
            case ChainId.ETH:
                return ETH_GAS_PARAMS;
            case ChainId.BOBA:
                return BOBA_GAS_PARAMS;
            case ChainId.ARBITRUM:
                return ARBITRUM_GAS_PARAMS;
            case ChainId.AVALANCHE:
                return AVALANCHE_GAS_PARAMS;
            case ChainId.AURORA:
                return AURORA_GAS_PARAMS;
        }
        return {};
    }
    GasUtils.makeGasParams = makeGasParams;
})(GasUtils || (GasUtils = {}));
