import { BigNumber, BigNumberish } from "@ethersproject/bignumber";
export interface BaseToken {
    readonly name: string;
    readonly symbol: string;
    readonly addresses: {
        [k: number]: string;
    };
    readonly swapType: string;
    readonly hash: string;
    address: (chainId: number) => string | null;
    decimals: (chainId: number) => number | null;
}
export declare class Token implements BaseToken {
    readonly name: string;
    readonly symbol: string;
    readonly addresses: {
        [k: number]: string;
    };
    readonly swapType: string;
    readonly isETH: boolean;
    readonly hash: string;
    protected readonly _decimals: {
        [k: number]: number;
    };
    constructor(args: {
        name: string;
        symbol: string;
        decimals: number | {
            [k: number]: number;
        };
        addresses: {
            [k: number]: string;
        };
        swapType: string;
        isETH?: boolean;
    });
    address(chainId: number): string | null;
    decimals(chainId: number): number | null;
    isEqual(other: Token): boolean;
    valueToWei(amt: BigNumberish, chainId: number): BigNumber;
}
