import { BigNumber } from "@ethersproject/bignumber";
import { parseUnits } from "@ethersproject/units";
export class Token {
    constructor(args) {
        var _a;
        this.addresses = {};
        this._decimals = {};
        this.name = args.name;
        this.symbol = args.symbol;
        this.addresses = args.addresses;
        this.swapType = args.swapType;
        if (typeof args.decimals === "number") {
            for (const [k, v] of Object.entries(this.addresses)) {
                this._decimals[k] = args.decimals;
            }
        }
        else {
            this._decimals = args.decimals;
        }
        this.isETH = (_a = args.isETH) !== null && _a !== void 0 ? _a : false;
        this.hash = Buffer.from(this.symbol).toString("base64");
    }
    address(chainId) {
        return this.addresses[chainId] || null;
    }
    decimals(chainId) {
        return this._decimals[chainId] || null;
    }
    isEqual(other) {
        return this.hash === other.hash;
    }
    valueToWei(amt, chainId) {
        let amtStr = BigNumber.from(amt).toString();
        return parseUnits(amtStr, this.decimals(chainId));
    }
}
